//*****************************************************************************************************
//  1. t@C
//		MyCtrl.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		gRg[NX̎
//----------------------------------------------------------------------------------------------------
//  3. l
//*****************************************************************************************************

#include "stdafx.h"
#include "MyCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define TS_MARGIN	10

/////////////////////////////////////////////////////////////////////////////
// CButtonEx


BEGIN_MESSAGE_MAP(CButtonEx, CButton)
	ON_WM_CTLCOLOR_REFLECT()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CButtonEx bZ[W nh

//*****************************************************************************************************
//  1. ֐
//		CButtonEx::CButtonEx
//----------------------------------------------------------------------------------------------------
//  2. @\
//		{^Rg[̃RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CButtonEx::CButtonEx()
{
	m_bSetTextColor = FALSE;
}

//*****************************************************************************************************
//  1. ֐
//		CButtonEx::operator=
//----------------------------------------------------------------------------------------------------
//  2. @\
//		{^Rg[ւBOOLIy[^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		BOOL	param			[I] `FbN
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
BOOL CButtonEx::operator=(BOOL param)
{
	if (GetCheck() != param)
		SetCheck(param);

	return param;
}

//*****************************************************************************************************
//  1. ֐
//		CButtonEx::operator BOOL
//----------------------------------------------------------------------------------------------------
//  2. @\
//		{^Rg[BOOLւ̃LXg
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	`FbN
//*****************************************************************************************************
CButtonEx::operator BOOL()
{
	return GetCheck();
}

//*****************************************************************************************************
//  1. ֐
//		CButtonEx::operator=
//----------------------------------------------------------------------------------------------------
//  2. @\
//		{^Rg[LPCTSTRIy[^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR	pText			[I] {^ɕ\镶
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		LPCTSTR		{^ɕ\镶
//*****************************************************************************************************
LPCTSTR CButtonEx::operator=(LPCTSTR pText)
{
	SetWindowText(pText);
	return pText;
}

//*****************************************************************************************************
//  1. ֐
//		CButtonEx::SetTextColor
//----------------------------------------------------------------------------------------------------
//  2. @\
//		{^Rg[̕Fݒ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		COLORREF	colorText			[I] F
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CButtonEx::SetTextColor(COLORREF colorText)
{
	m_colorText = colorText;
	m_bSetTextColor = TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CButtonEx::SetBackColor
//----------------------------------------------------------------------------------------------------
//  2. @\
//		{^Rg[̔wiFݒ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		COLORREF	colorBack			[I] wiF
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CButtonEx::SetBackColor(COLORREF colorBack)
{
	m_brushBG.DeleteObject();
	m_brushBG.CreateSolidBrush(colorBack);
}

//*****************************************************************************************************
//  1. ֐
//		CButtonEx::CtlColor
//----------------------------------------------------------------------------------------------------
//  2. @\
//		{^Rg[WM_CTLCOLORbZ[Wnh
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC		*pDC			[I] foCXReLXg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		HBRUSH		wĩuV
//*****************************************************************************************************
HBRUSH CButtonEx::CtlColor(CDC* pDC, UINT /*nCtlColor*/)
{
	HBRUSH brush = NULL;

	if (m_bSetTextColor) {
		pDC->SetTextColor(m_colorText);
		pDC->SetBkColor(::GetSysColor(COLOR_3DFACE));
		brush = (HBRUSH)::GetSysColorBrush(COLOR_3DFACE);
	}	

	if (m_brushBG.m_hObject)
		brush = (HBRUSH)m_brushBG.m_hObject;

	return brush;
}

/////////////////////////////////////////////////////////////////////////////
// CEditEx

//*****************************************************************************************************
//  1. ֐
//		CEditEx::CEditEx
//----------------------------------------------------------------------------------------------------
//  2. @\
//		GfBbgRg[̃RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CEditEx::CEditEx()
{
	m_bSetTextColor = FALSE;
	m_nTextColor = (COLORREF)-1;
}


BEGIN_MESSAGE_MAP(CEditEx, CEdit)
	ON_WM_CTLCOLOR_REFLECT()
	ON_WM_CHAR()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditEx bZ[W nh

//*****************************************************************************************************
//  1. ֐
//		CEditEx::operator=
//----------------------------------------------------------------------------------------------------
//  2. @\
//		GfBbgRg[ւintIy[^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int		param			[I] intl
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		int		intl
//*****************************************************************************************************
int CEditEx::operator=(int param)
{
	CString str1, str2;

	str1.Format("%d", param);
	GetWindowText(str2);

	if (str1 != str2) {
		SetWindowText(str1);
		UpdateWindow();
	}

	return param;
}

//*****************************************************************************************************
//  1. ֐
//		CEditEx::operator=
//----------------------------------------------------------------------------------------------------
//  2. @\
//		GfBbgRg[ւdoubleIy[^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		double		param			[I] doublel
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		double		doublel
//*****************************************************************************************************
double CEditEx::operator=(double param)
{
	CString str1, str2;

	str1.Format("%g", param);
	GetWindowText(str2);

	if (str1 != str2) {
		SetWindowText(str1);
		UpdateWindow();
	}

	return param;
}

//*****************************************************************************************************
//  1. ֐
//		CEditEx::operator=
//----------------------------------------------------------------------------------------------------
//  2. @\
//		GfBbgRg[ւCStringIy[^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CString		&param			[I] CStringl
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		CString		CStringl
//*****************************************************************************************************
CString &CEditEx::operator=(CString &param)
{
	CString str2;

	GetWindowText(str2);

	if (param != str2) {
		SetWindowText(param);
		UpdateWindow();
	}

	return param;
}

//*****************************************************************************************************
//  1. ֐
//		CEditEx::operator=
//----------------------------------------------------------------------------------------------------
//  2. @\
//		GfBbgRg[ւLPCTSTRIy[^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR		param			[I] LPCTSTRl
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		LPCTSTR		LPCTSTRl
//*****************************************************************************************************
LPCTSTR CEditEx::operator=(LPCTSTR param)
{
	CString str2;

	GetWindowText(str2);

	if (str2 != param) {
		SetWindowText(param);
		UpdateWindow();
	}

	return param;
}

//*****************************************************************************************************
//  1. ֐
//		CEditEx::operator=
//----------------------------------------------------------------------------------------------------
//  2. @\
//		GfBbgRg[ւCEditExIy[^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CEditEx		&param			[I] CEditExRg[
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		CEditEx		CEditExRg[
//*****************************************************************************************************
CEditEx &CEditEx::operator=(CEditEx &param)
{
	CString str;

	param.GetWindowText(str);
	SetWindowText(str);
	UpdateWindow();

	return param;
}

//*****************************************************************************************************
//  1. ֐
//		CEditEx::operator==
//----------------------------------------------------------------------------------------------------
//  2. @\
//		GfBbgRg[LPCTSTR==ZIy[^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR		param			[I] rLPCTSTRl
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		int			Z
//*****************************************************************************************************
int CEditEx::operator==(LPCTSTR param)
{
	GetWindowText(m_str);
	return m_str == param;
}

//*****************************************************************************************************
//  1. ֐
//		CEditEx::operator==
//----------------------------------------------------------------------------------------------------
//  2. @\
//		GfBbgRg[int==ZIy[^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int		param			[I] rintl
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		int			r
//*****************************************************************************************************
int CEditEx::operator==(int param)
{
	GetWindowText(m_str);
	return atoi(m_str) == param;
}

//*****************************************************************************************************
//  1. ֐
//		CEditEx::operator!=
//----------------------------------------------------------------------------------------------------
//  2. @\
//		GfBbgRg[int!=ZIy[^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int		param			[I] rintl
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		int			r
//*****************************************************************************************************
int CEditEx::operator!=(int param)
{
	GetWindowText(m_str);
	return atoi(m_str) != param;
}

//*****************************************************************************************************
//  1. ֐
//		CEditEx::operator int
//----------------------------------------------------------------------------------------------------
//  2. @\
//		GfBbgRg[intւ̃LXg
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		int			LXgintl
//*****************************************************************************************************
CEditEx::operator int()
{
	GetWindowText(m_str);
	return atoi(m_str);
}

//*****************************************************************************************************
//  1. ֐
//		CEditEx::operator double
//----------------------------------------------------------------------------------------------------
//  2. @\
//		GfBbgRg[doubleւ̃LXg
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		double		LXgdoublel
//*****************************************************************************************************
CEditEx::operator double()
{
	GetWindowText(m_str);
	return atof(m_str);
}

//*****************************************************************************************************
//  1. ֐
//		CEditEx::operator CString
//----------------------------------------------------------------------------------------------------
//  2. @\
//		GfBbgRg[CStringւ̃LXg
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		CString		LXgCStringl
//*****************************************************************************************************
CEditEx::operator CString()
{
	GetWindowText(m_str);
	return m_str;
}

//*****************************************************************************************************
//  1. ֐
//		CEditEx::IsEmpty
//----------------------------------------------------------------------------------------------------
//  2. @\
//		󕶎`FbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		󕶎̏ꍇTRUEAȊOFALSE
//*****************************************************************************************************
BOOL CEditEx::IsEmpty()
{
	GetWindowText(m_str);
	return m_str.IsEmpty();
}

//*****************************************************************************************************
//  1. ֐
//		CEditEx::Format
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ɂ镶ݒ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR		lpszFormat			[I] 
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CEditEx::Format(LPCTSTR lpszFormat, ...)
{
	va_list vl;
	char str[256];
	CString str2;

	va_start(vl, lpszFormat);
	vsprintf_s(str, lpszFormat, vl);

	GetWindowText(str2);

	if (str2 != str) {
		SetWindowText(str);
		UpdateWindow();
	}
}

//*****************************************************************************************************
//  1. ֐
//		CEditEx::Blank
//----------------------------------------------------------------------------------------------------
//  2. @\
//		󕶎ݒ肷
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CEditEx::Blank()
{
	CString str;

	GetWindowText(str);
	if (!str.IsEmpty()) {
		SetWindowText("");
		UpdateWindow();
	}
}

//*****************************************************************************************************
//  1. ֐
//		CEditEx::SetTextColor
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Fݒ肷
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		COLORREF	color			[I] F
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CEditEx::SetTextColor(COLORREF color)
{
	if (!m_bSetTextColor) {
		m_Brush.CreateSolidBrush(::GetSysColor(COLOR_3DFACE));
		m_bSetTextColor = TRUE;
	}

	if (color != m_nTextColor) {
		m_nTextColor = color;
		Invalidate();
	}
}

//*****************************************************************************************************
//  1. ֐
//		CEditEx::CtlColor
//----------------------------------------------------------------------------------------------------
//  2. @\
//		GfBbgRg[WM_CTLCOLORbZ[Wnh
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC		*pDC			[I] foCXReLXg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		HBRUSH		wĩuV
//*****************************************************************************************************
HBRUSH CEditEx::CtlColor(CDC* pDC, UINT /*nCtlColor*/) 
{
	if (m_bSetTextColor) {
		pDC->SetTextColor(m_nTextColor);
		pDC->SetBkMode(TRANSPARENT);
		return (HBRUSH)m_Brush;
	}

	return NULL;
}

//*****************************************************************************************************
//  1. ֐
//		CEditEx::SetValidChar
//----------------------------------------------------------------------------------------------------
//  2. @\
//		GfBbgRg[ɓ͉\ȕނ̐ݒ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nValidChar			[I] 
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CEditEx::SetValidChar(UINT nValidChar)
{
	m_sValidStr = "\b\x03\x16\x18";		// BS,CTRL+C,CTRL+V,CTRL+X
	if (nValidChar & VC_NUM)
		m_sValidStr += "0123456789";
	if (nValidChar & VC_MINUS)
		m_sValidStr += "-";
	if (nValidChar & VC_POINT)
		m_sValidStr += ".";
	if (nValidChar & VC_EXP)
		m_sValidStr += "eE";
}

//*****************************************************************************************************
//  1. ֐
//		CEditEx::OnChar
//----------------------------------------------------------------------------------------------------
//  2. @\
//		GfBbgRg[WM_CHARbZ[Wnh
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT	nChar			[I] ͂ꂽ
//		UINT	nRepCnt			[I] s[gJEg
//		UINT	nFlags			[I] tO
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CEditEx::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	switch(nChar) {
	case 0x0d:
		GetParent()->SendMessage(WM_KEY_RET_KEY, this->GetDlgCtrlID(), 0);
		return;
	case 0x09:
		break;
	default:
//		break;
		if (!m_sValidStr.IsEmpty()) {
			if (strchr(m_sValidStr, nChar) == NULL) {
				MessageBeep(0);
				return;
			}
		}
	}

	CEdit::OnChar(nChar, nRepCnt, nFlags);
}


// CStaticEx

IMPLEMENT_DYNAMIC(CStaticEx, CStatic)


BEGIN_MESSAGE_MAP(CStaticEx, CStatic)
	ON_WM_CTLCOLOR_REFLECT()
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_MESSAGE(WM_MOUSELEAVE, &CStaticEx::OnMouseLeave)
END_MESSAGE_MAP()



// CStaticEx bZ[W nh

//*****************************************************************************************************
//  1. ֐
//		CStaticEx::CStaticEx
//----------------------------------------------------------------------------------------------------
//  2. @\
//		X^eBbNRg[̃RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CStaticEx::CStaticEx()
{
	m_bSetTextColor = FALSE;
	m_bMouseTrack = FALSE;
	m_bMouseIn = FALSE;
}

//*****************************************************************************************************
//  1. ֐
//		CStaticEx::operator=
//----------------------------------------------------------------------------------------------------
//  2. @\
//		X^eBbNRg[ւLPCTSTRIy[^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR		pText			[I] LPCTSTRl
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		LPCTSTR		LPCTSTRl
//*****************************************************************************************************
LPCTSTR CStaticEx::operator=(LPCTSTR pText)
{
	SetWindowText(pText);
	return pText;
}

//*****************************************************************************************************
//  1. ֐
//		CStaticEx::SetTextColor
//----------------------------------------------------------------------------------------------------
//  2. @\
//		X^eBbNRg[̕Fݒ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		COLORREF	colorText			[I] F
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CStaticEx::SetTextColor(COLORREF colorText)
{
	m_colorText = colorText;
	m_bSetTextColor = TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CStaticEx::SetBackColor
//----------------------------------------------------------------------------------------------------
//  2. @\
//		X^eBbNRg[̔wiFݒ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		COLORREF	colorBack			[I] wiF
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CStaticEx::SetBackColor(COLORREF colorBack)
{
	m_brushBG.DeleteObject();
	m_brushBG.CreateSolidBrush(colorBack);
}

//*****************************************************************************************************
//  1. ֐
//		CStaticEx::ResetBackColor
//----------------------------------------------------------------------------------------------------
//  2. @\
//		X^eBbNRg[̔wiFɖ߂
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CStaticEx::ResetBackColor()
{
	m_brushBG.DeleteObject();
}

//*****************************************************************************************************
//  1. ֐
//		CStaticEx::Blank
//----------------------------------------------------------------------------------------------------
//  2. @\
//		X^eBbNRg[ɃuNݒ肷
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CStaticEx::Blank()
{
	CString str;

	GetWindowText(str);
	if (!str.IsEmpty()) {
		SetWindowText("");
		UpdateWindow();
	}
}

//*****************************************************************************************************
//  1. ֐
//		CStaticEx::CtlColor
//----------------------------------------------------------------------------------------------------
//  2. @\
//		X^eBbNRg[WM_CTLCOLORbZ[Wnh
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC		*pDC			[I] foCXReLXg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		HBRUSH		wĩuV
//*****************************************************************************************************
HBRUSH CStaticEx::CtlColor(CDC* pDC, UINT /*nCtlColor*/)
{
	HBRUSH brush = NULL;

	if (m_bSetTextColor) {
		pDC->SetTextColor(m_colorText);
		pDC->SetBkColor(::GetSysColor(COLOR_3DFACE));
		brush = (HBRUSH)::GetSysColorBrush(COLOR_3DFACE);
	}	

	if (m_brushBG.m_hObject) {
		pDC->SetBkMode(TRANSPARENT);
		brush = (HBRUSH)m_brushBG.m_hObject;
	}

	return brush;
}

//*****************************************************************************************************
//  1. ֐
//		CStaticEx::OnPaint
//----------------------------------------------------------------------------------------------------
//  2. @\
//		X^eBbNRg[WM_PAINTbZ[Wnh
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CStaticEx::OnPaint()
{
	if ((GetStyle() & SS_BLACKRECT) && m_brushBG.m_hObject) {
		CPaintDC dc(this);

		CRect rect;
		GetClientRect(rect);
		dc.FillRect(rect, &m_brushBG);
	} else
		CStatic::OnPaint();
}

void CStaticEx::SetMouseTrack(BOOL bMouseTrack)
{
	m_bMouseTrack = bMouseTrack;
}

void CStaticEx::OnMouseMove(UINT nFlags, CPoint point)
{
	if (m_bMouseTrack) {
		if (!m_bMouseIn) {
			TRACKMOUSEEVENT tme = {0};
			tme.cbSize = sizeof(TRACKMOUSEEVENT);
			tme.dwFlags = TME_LEAVE;
			tme.hwndTrack = m_hWnd;
			_TrackMouseEvent(&tme);

			GetParent()->SendMessage(WM_MOUSEIN, (WPARAM)m_hWnd);
			m_bMouseIn = TRUE;
		}
	}

	CStatic::OnMouseMove(nFlags, point);
}

LRESULT CStaticEx::OnMouseLeave(WPARAM wparam, LPARAM lparam)
{
	GetParent()->SendMessage(WM_MOUSEOUT, (WPARAM)m_hWnd);
	m_bMouseIn = FALSE;

	return 0;
}
